commit 7408a0b93e6f6b3ce9b6be17bb9b5d2307f5ecf1
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue May 9 12:14:18 2023

    testsuite: Add further testcase for already fixed PR [PR109778]
    
    I came up with a testcase which reproduces all the way to r10-7469.
    LTO to avoid early inlining it, so that ccp handles rotates and not
    shifts before they are turned into rotates.
    
    2023-05-09  Jakub Jelinek  <jakub@redhat.com>
    
            PR tree-optimization/109778
            * gcc.dg/lto/pr109778_0.c: New test.
            * gcc.dg/lto/pr109778_1.c: New file.
    
    (cherry picked from commit c2cf2dc988eb93551fa1c01d3f8d73ef21f39dc5)

diff --git a/gcc/testsuite/gcc.dg/lto/pr109778_0.c b/gcc/testsuite/gcc.dg/lto/pr109778_0.c
new file mode 100644
index 00000000000..3c6e1b8f7b7
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/lto/pr109778_0.c
@@ -0,0 +1,22 @@
+/* PR tree-optimization/109778 */
+/* { dg-lto-do run } */
+/* { dg-lto-options { "-O2 -flto" } } */
+/* { dg-require-effective-target int32 } */
+
+int bar (int);
+
+__attribute__((noipa)) int
+foo (int x)
+{
+  x = bar (x);
+  x = (x << 16) | (int) ((unsigned) x >> 16);
+  return x & 0x10000000;
+}
+
+int
+main ()
+{
+  if (foo (0) || foo (-1))
+    __builtin_abort ();
+  return 0;
+}
diff --git a/gcc/testsuite/gcc.dg/lto/pr109778_1.c b/gcc/testsuite/gcc.dg/lto/pr109778_1.c
new file mode 100644
index 00000000000..d18a7209983
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/lto/pr109778_1.c
@@ -0,0 +1,7 @@
+int
+bar (int x)
+{
+  x &= 0x22222222;
+  x |= (int) 0xf1234567U;
+  return x;
+}

